package com.youtube.user.SvizelPritula.moonlander;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Timer;
import java.util.TimerTask;

import javax.swing.JFrame;

public class Main {
	static String adress;
	static int number=-3;
	
	static double x=0; //Souadnice x RELATIVN K PROSTEDKU PLOINY
	static double y=10; //Souadnice y RELATIVN K PROSTEDKU PLOINY
	static double vx=0; //Rychlost x
	static double vy=0; //Rychlost y
	static double p=5; //Stav paliva
	static double cw=50; //ika ploiny (Souadnice jsou relativn k jejmu stedu)
	
	static boolean up=false;
	static boolean left=false;
	static boolean right=false;
	
	static Timer timer=new Timer();
	static JFrame frame;
	
	public static void main(String[] args) {
		if (args.length>0) {
			adress=args[0];
		} else {
			System.out.println("Zadejte adresu jako parametr");
			System.exit(1);
		}
		
		frame=new JFrame("Moonlander v156.32");
		frame.setSize(200, 200);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.add(new MoonlanderDisplay());
		frame.setVisible(true);
		frame.addKeyListener(new DirectionListener());
		
	}

	static void start() {
		try {
			HttpURLConnection con=(HttpURLConnection) new URL("http://"+adress+"/start").openConnection();
			con.setRequestMethod("GET");
			BufferedReader br=new BufferedReader(new InputStreamReader(con.getInputStream()));
			number=Integer.parseInt(br.readLine());
			br.close();
		} catch (IOException e) {
			System.out.println("Nco se nepovedlo");
		}
		
		timer.scheduleAtFixedRate(new TimerTask() {
			
			@Override
			public void run() {
				update();
				
			}
		}, 50, 50);
		
		update();
	}
	
	private static void update() {
		try {
			StringBuilder sb=new StringBuilder();
			sb.append("http://");
			sb.append(adress);
			sb.append("/stav?");
			
			sb.append("id=");
			sb.append(number);
			sb.append("&");
			
			sb.append("nahoru=");
			sb.append(up?1:0);
			sb.append("&");
			
			sb.append("doleva=");
			sb.append(left?1:0);
			sb.append("&");
			
			sb.append("doprava=");
			sb.append(right?1:0);
					
			HttpURLConnection con=(HttpURLConnection) new URL(sb.toString()).openConnection();
			con.setRequestMethod("GET");
			
			BufferedReader br=new BufferedReader(new InputStreamReader(con.getInputStream()));
			
			String mainResponse=br.readLine();
			if(mainResponse.endsWith("!")) {
				
				number=-3;
				
				if (mainResponse.equals("Zdar!")) {
					number=-1;
				}
				
				if (mainResponse.equals("Krach!")) {
					number=-2;
				}
				
				timer.cancel();
				timer=new Timer();
				
				if (frame!=null) {
					frame.repaint();
				}
				
				return;
			}
			
			String[] xAndY=br.readLine().split(" ");
			double x=Double.parseDouble(xAndY[0]);
			double y=Double.parseDouble(xAndY[1]);
			
			String[] vxAndVy=br.readLine().split(" ");
			vx=Double.parseDouble(vxAndVy[0]);
			vy=Double.parseDouble(vxAndVy[1]);
			
			p=Double.parseDouble(br.readLine());
			
			String[] cxAndCy=br.readLine().split(" ");
			double cl=Double.parseDouble(cxAndCy[0]);
			double cr=Double.parseDouble(cxAndCy[1]);
			double c=(cl+cr)/2;
			cw=cr-cl;
			
			Main.x=x-c;
			Main.y=y;
			
			br.close();
			
		} catch (IOException e) {
			System.out.println("Nco se nepovedlo");
		}
		
		if (frame!=null) {
			frame.repaint();
		}
	}

}
