package com.youtube.user.SvizelPritula.moonlander;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JPanel;

public class MoonlanderDisplay extends JPanel {
	private static final long serialVersionUID = 4709668527394711293L;
	
	Image img;
	int points=Integer.MAX_VALUE;
	
	public MoonlanderDisplay() {
		try {
			img=ImageIO.read(getClass().getResource("/com/youtube/user/SvizelPritula/moonlander/lunar_lander.png"));
		} catch (IOException e) {
		}
	}
	
	@Override
	public void paint(Graphics gntd) {
		Graphics2D g=(Graphics2D) gntd;
		super.paint(g);
		
		int goodPoints=(int) Math.max(Math.max(Math.abs(Main.x*2),Main.y)+100,200);
		
		if ((points-goodPoints)>200) {
			points=goodPoints+200;
		}
		if ((goodPoints-points)>20) {
			points=goodPoints-20;
		}
		
		double zoom=(double)getWidth()/points;
		
		g.setStroke(new BasicStroke((float) (10*zoom)));
		
		g.setColor(new Color(0, 0, 0));
		g.drawLine(0, getHeight(), getWidth(), getHeight());
		
		if (Math.abs(Main.vx)<=5&&Math.abs(Main.vy)<=5) {
			g.setColor(new Color(0, 200, 0));
		} else {
			g.setColor(new Color(200, 0, 0));
		}
		g.drawLine((int)(getWidth()/2-(Main.cw/2)*zoom), getHeight(), (int)(getWidth()/2+(Main.cw/2)*zoom), getHeight());
		
		g.drawImage(img, getWidth()/2+(int)((Main.x-10)*zoom),  getHeight()-(int)((Main.y+15)*zoom), (int) (20*zoom), (int) (20*zoom), g.getBackground(), null);
		
		double guiFix=getWidth()/(double)500;
		
		g.setColor(new Color(0,0,0));
		g.setFont(new Font(null,Font.PLAIN,(int) (20*guiFix)));
		g.drawString("Palivo:", (int) (10*guiFix), (int) (30*guiFix));
		
		g.setColor(new Color(0,0,0));
		g.setFont(new Font(null,Font.BOLD,(int) (20*guiFix)));
		g.drawString(Double.toString(Math.round(Main.p*100)/(double)100)+" jl", (int) (120*guiFix), (int) (30*guiFix));
		
		g.setColor(new Color(0,0,0));
		g.setFont(new Font(null,Font.PLAIN,(int) (20*guiFix)));
		g.drawString("Vzdlenost:", (int) (10*guiFix), (int) (60*guiFix));
		
		g.setColor(new Color(0,0,0));
		g.setFont(new Font(null,Font.BOLD,(int) (20*guiFix)));
		g.drawString(Long.toString(Math.round(Math.max(Math.abs(Main.x)-Main.cw/2+10,0)))+" jm", (int) (120*guiFix), (int) (60*guiFix));
		
		String text;
		
		if (Main.number==-1) {
			g.setColor(new Color(0,200,0));
			g.setFont(new Font(null,Font.BOLD,(int) (50*guiFix)));
			text="Povedlo se";
			g.drawString(text, getWidth()/2-(int)(g.getFontMetrics().stringWidth(text)/2), getHeight()/2);
		}
		
		if (Main.number==-2) {
			g.setColor(new Color(200,0,0));
			g.setFont(new Font(null,Font.BOLD,(int) (50*guiFix)));
			text="Nepovedlo se";
			g.drawString(text, getWidth()/2-(int)(g.getFontMetrics().stringWidth(text)/2), getHeight()/2);
		}
	}
}
